/* 
 * atl-std-opts.h
 *
 * Standard set of options for Allied Telesis devices 
 *
 * Matthew Millman (matthewm.millman@alliedtelesis.co.nz)
 *
 */

#define CONFIG_BAUDRATE	        9600	
#define __ATL_CHANGE__

/*#define CONFIG_SYS_NO_FLASH*/

#define CONFIG_CMD_DFL
#define CONFIG_CMD_PING
#define CONFIG_CMD_ELF
#define CONFIG_CMD_ENV
#define CONFIG_CMD_JFFS2
#define CONFIG_CMD_FLASH
#define CONFIG_CMD_AWP
#define CONFIG_CMD_FAT
#define CONFIG_CMD_PCI
#define CONFIG_CMD_DATE


#ifndef CONFIG_SYS_NO_FLASH
#define CONFIG_GENERIC_COMMANDS _CONFIG_GENERIC_COMMANDS
#define CONFIG_ENV_IS_IN_FLASH
#define CONFIG_SYS_JFFS2_SORT_FRAGMENTS
#else
#undef CONFIG_CMD_ENV
#undef CONFIG_CMD_FLASH
#undef CONFIG_CMD_JFFS2
#undef CONFIG_CMD_IMLS
#define CONFIG_SYS_ENV_IS_NOWHERE
#endif

#define CONFIG_RTC_DS1302_ATL
#define CONFIG_IPV6

#define CONFIG_RELEASEFILE_EXT ".rel"
#define CONFIG_BOOTFILE_EXT ".bin"

#if defined (CONFIG_CMD_KGDB)
#define	CONFIG_SYS_CBSIZE	1024		        /* Console I/O Buffer Size	*/
#else
#define	CONFIG_SYS_CBSIZE	256		        /* Console I/O Buffer Size	*/
#endif

#define CONFIG_SILENT_CONSOLE

#define CONFIG_CMDLINE_EDITING

#define CONFIG_BOOTDELAY	3	        /* autoboot after 3 seconds	*/

#undef	CONFIG_WATCHDOG		        	/* disable platform specific watchdog */

#define	CONFIG_SYS_LONGHELP			        /* undef to save memory		*/

#define CONFIG_SYS_BARGSIZE            CONFIG_SYS_CBSIZE      /* Boot Argument Buffer Size    */
#define CONFIG_SYS_MAXARGS		32
#define     CONFIG_SYS_PBSIZE (CONFIG_SYS_CBSIZE+sizeof(CONFIG_SYS_PROMPT)+16) /* Print Buffer Size */

#define	CONFIG_SYS_HZ		1000		/* decrementer freq: 1 ms ticks	*/

#define CONFIG_SYS_BAUDRATE_TABLE	{ 9600, 19200, 38400, 57600, 115200 }

#define	CONFIG_SYS_MONITOR_LEN		(256 << 10)	/* Reserve 256 kB for Monitor	*/
#define	CONFIG_SYS_MALLOC_LEN		(2048 << 10)	/* Reserve 2 MB for malloc()*/

/*
 * For booting Linux, the board info and command line data
 * have to be in the first 8 MB of memory, since this is
 * the maximum mapped by the Linux kernel during initialization.
 */

#define	CONFIG_SYS_BOOTMAPSZ		(8 << 20)	/* Initial Mem map for Linux*/

/* Console related */

/* Use the HUSH parser */

#define CONFIG_SYS_HUSH_PARSER
#ifdef  CONFIG_SYS_HUSH_PARSER
#define CONFIG_SYS_PROMPT_HUSH_PS2 "> "
#endif

#define CONFIG_SYS_CONSOLE_INFO_QUIET	1

#define CONFIG_LOADS_ECHO	1	/* echo on for serial download */
#define CONFIG_SYS_LOADS_BAUD_CHANGE	1	/* allow baudrate change */

/* Boot Flag */

#define BOOTFLAG_COLD	0x01		/* Normal Power-On: Boot from FLASH*/
#define BOOTFLAG_WARM	0x02		/* Software reboot		*/

/* The mac addresses for all ethernet interface */

#define CONFIG_ETHADDR   00:00:cd:00:00:FD /*  change this to an ATR one */

/* Default environemnt settings */

#define CONFIG_IPADDR    0.0.0.0
#define CONFIG_SERVERIP  0.0.0.0
#define CONFIG_GATEWAYIP 0.0.0.0
#define CONFIG_NETMASK   0.0.0.0

#define CONFIG_SYS_LOAD_ADDR  1000000	/* default location for tftp and bootm */
#define CONFIG_LOADADDR  CONFIG_SYS_LOAD_ADDR

#undef  CONFIG_BOOTARGS		        /* the boot command will set bootargs */       

#ifndef CONFIG_BOARD_EXTRA_ENV_SETTINGS
#define CONFIG_BOARD_EXTRA_ENV_SETTINGS
#endif

#ifndef CONFIG_BOOTCMD_ENV_SETTING
#define CONFIG_BOOTCMD_ENV_SETTING "awbootf"
#endif

#define	CONFIG_EXTRA_ENV_SETTINGS	\
   CONFIG_BOARD_EXTRA_ENV_SETTINGS	\
   "bootcmd=" CONFIG_BOOTCMD_ENV_SETTING "\0"	\
   "loglevel=1\0"			\
   "silent=1"				


